Subject: Re: [PATCH] git-repack doc: remove discussion of ancient caveat

From: Junio C Hamano <[email-masked]>
Date: Fri, 15 Jul 2022 09:53:46 -0700

Ævar Arnfjörð Bjarmason  <[email-masked]> writes:

> The backwards compatibility caveat discussed her hasn't been a concern
> for anyone after Git v1.6.0. Let's simply remove it, I daresay
> nobody's concerned these days with having git clients running older
> than 2008-era git.

For the purpose of this message, Git 1.6.0 has no significance.
Anything newer than 1.4.4 should be able to understand packfiles
that use delta-base-offset, even though they may not have used
delta-base-offset when writing a new one.

That's all academic.  I wouldn't have written the above if the
proposed log message stopped here.  But with the rest of proposed
log message that hints that the above statement is backed by a solid
study of history, it is wrong to write a wrong version number there.

I agree that it is safe to say that anything before Git 2.0.0 is
irrelevant at this point (I would actually say before Git 2.16.0,
i.e. anything older than 3-4 years).

> See b6945f570ac (git-repack: repo.usedeltabaseoffset, 2006-10-13) and
> 9f17688d93c (update git-repack documentation wrt
> repack.UseDeltaBaseOffset, 2010-02-04) for the commits that previously
> introduced and adjusted this documentation.
>
> Signed-off-by: Ævar Arnfjörð Bjarmason <[email-masked]>
> ---
>  Documentation/git-repack.txt | 10 ----------
>  1 file changed, 10 deletions(-)
>
> diff --git a/Documentation/git-repack.txt b/Documentation/git-repack.txt
> index 0bf13893d81..fe1eac37090 100644
> --- a/Documentation/git-repack.txt
> +++ b/Documentation/git-repack.txt
> @@ -218,16 +218,6 @@ CONFIGURATION
>  Various configuration variables affect packing, see
>  linkgit:git-config[1] (search for "pack" and "delta").
>  
> -By default, the command passes `--delta-base-offset` option to
> -'git pack-objects'; this typically results in slightly smaller packs,
> -but the generated packs are incompatible with versions of Git older than
> -version 1.4.4. If you need to share your repository with such ancient Git
> -versions, either directly or via the dumb http protocol, then you
> -need to set the configuration variable `repack.UseDeltaBaseOffset` to
> -"false" and repack. Access from old Git versions over the native protocol
> -is unaffected by this option as the conversion is performed on the fly
> -as needed in that case.
> -
>  Delta compression is not used on objects larger than the
>  `core.bigFileThreshold` configuration variable and on files with the
>  attribute `delta` set to false.